/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.40 Revision 1.129
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.40 2009/06/27 18:55:02 yngwin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.129 2012/05/20 17:12:34 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
14inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
15 18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
16IUSE="${IUSE} debug pch" 43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="virtual/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
17RDEPEND=" 56RDEPEND="
18 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
19 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
20 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
21 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
22 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
23 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
24 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
25 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
26 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
27 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
28 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
29 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
30 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
31 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
32 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
33 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
34 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
42 !<x11-libs/qt-webkit-${PV} 89 !<x11-libs/qt-webkit-${PV}
43 !>x11-libs/qt-webkit-${PV}-r9999 90 !>x11-libs/qt-webkit-${PV}-r9999
44 !<x11-libs/qt-xmlpatterns-${PV} 91 !<x11-libs/qt-xmlpatterns-${PV}
45 !>x11-libs/qt-xmlpatterns-${PV}-r9999 92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
46" 93"
47case "${PV}" in 94
48 4.?.?_rc*)
49 SRCTYPE="${SRCTYPE:-opensource-src}"
50 MY_PV="${PV/_rc/-rc}"
51 ;;
52 *)
53 SRCTYPE="${SRCTYPE:-opensource-src}"
54 MY_PV="${PV}"
55 ;;
56esac
57MY_P=qt-x11-${SRCTYPE}-${MY_PV}
58S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
59 96
60HOMEPAGE="http://www.qtsoftware.com/"
61SRC_URI="http://get.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
62
63case "${PV}" in
64 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
65 *) ;;
66esac
67
68if version_is_at_least 4.5 ${PV} ; then
69 LICENSE="|| ( LGPL-2.1 GPL-3 )"
70fi
71
72# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
73# @DESCRIPTION: 98# @DESCRIPTION:
74# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
75qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
76 # EAPI=2 ebuilds set use-deps, others need this: 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
77 if [[ $EAPI != 2 ]]; then 102
78 # Make sure debug setting corresponds with qt-core (bug 258512) 103 # Protect users by not allowing downgrades between releases
79 if [[ $PN != "qt-core" ]]; then 104 # Downgrading revisions within the same release should be allowed
80 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 105 if has_version '>'${CATEGORY}/${P}-r9999; then
81 ~x11-libs/qt-core-${PV} debug" 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
82 fi 114 fi
115 fi
83 116
84 # Check USE requirements 117 if [[ ${PN} == qt-webkit ]]; then
85 qt4-build_check_use 118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
86 fi 126 fi
87 # Set up installation directories 127 eshopts_pop
88 QTBASEDIR=/usr/$(get_libdir)/qt4 128 fi
89 QTPREFIXDIR=/usr
90 QTBINDIR=/usr/bin
91 QTLIBDIR=/usr/$(get_libdir)/qt4
92 QTPCDIR=/usr/$(get_libdir)/pkgconfig
93 QTDATADIR=/usr/share/qt4
94 QTDOCDIR=/usr/share/doc/qt-${PV}
95 QTHEADERDIR=/usr/include/qt4
96 QTPLUGINDIR=${QTLIBDIR}/plugins
97 QTSYSCONFDIR=/etc/qt4
98 QTTRANSDIR=${QTDATADIR}/translations
99 QTEXAMPLESDIR=${QTDATADIR}/examples
100 QTDEMOSDIR=${QTDATADIR}/demos
101 129
102 PLATFORM=$(qt_mkspecs_dir)
103
104 PATH="${S}/bin:${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then
105 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
133 else
134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
136 # platform detection. Note: needs to come before any directories to
137 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}"
141 fi
106 142
107 if ! version_is_at_least 4.1 $(gcc-version) ; then 143 if ! version_is_at_least 4.1 $(gcc-version); then
108 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
109 echo
110 ebeep 3
111 fi 145 fi
112} 146}
113 147
114# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
115# @DESCRIPTION: 149# @DESCRIPTION:
116# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
117# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
118 152
119# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
120# @DESCRIPTION: 154# @DESCRIPTION:
121# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
122# tarball 156# Qt tarball.
123 157
124# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
125# @DESCRIPTION: 159# @DESCRIPTION:
126# Unpacks the sources 160# Unpacks the sources.
127qt4-build_src_unpack() { 161qt4-build_src_unpack() {
128 local target targets licenses 162 setqtenv
129 if version_is_at_least 4.5 ${PV} ; then 163
130 licenses="LICENSE.GPL3 LICENSE.LGPL" 164 case ${QT4_BUILD_TYPE} in
131 else 165 live)
132 licenses="LICENSE.GPL2 LICENSE.GPL3" 166 git-2_src_unpack
133 fi 167 ;;
134 for target in configure ${licenses} projects.pro \ 168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
135 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
136 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
137 targets="${targets} ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
138 done 175 done
139 176
140 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
141 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 179 eend $? || die "failed to unpack"
143 case "${PV}" in
144 4.4.?)
145 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
146 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
147 ;; 180 ;;
148 esac 181 esac
149
150 # Be backwards compatible for now
151 if [[ $EAPI != 2 ]]; then
152 qt4-build_src_prepare
153 fi
154} 182}
155 183
156# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
157# @DESCRIPTION: 186# @DESCRIPTION:
158# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
159# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
160# example: 189# Make sure to specify the full path. This variable is utilised in
161# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
162# ${FILESDIR}"/mypatch2.patch"
163# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
164 196
165# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
166# @DESCRIPTION: 198# @DESCRIPTION:
167# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
168# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
169qt4-build_src_prepare() { 201qt4-build_src_prepare() {
170 cd "${S}" 202 setqtenv
203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215
216 if use aqua; then
217 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219
220 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi
171 224
172 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
173 skip_qmake_build_patch 226 skip_qmake_build
174 skip_project_generation_patch 227 skip_project_generation
175 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
176 fi 229 fi
177 230
231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
234 replace-flags -O[23] -O1
235 fi
236
178 # Bug 178652 237 # Bug 178652
179 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
180 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
181 append-flags -fno-gcse 240 append-flags -fno-gcse
182 fi 241 fi
183 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
184 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
185 if [[ $(gcc-major-version) -lt "4" ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
186 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
187 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
188 # Bug 253127 258 # Bug 253127
189 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
190 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
261 fi
262
263 # Bug 261632
264 if use ppc64; then
265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
266 append-flags -mminimal-toc
267 fi
268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 if ! version_is_at_least 4.8; then
287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
191 fi 289 fi
192 290
193 # Bug 172219 291 # Bug 172219
292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293
294 if [[ ${CHOST} == *-darwin* ]]; then
295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
194 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
195 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
196 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
197 -e "s:X11R6/::" \ 311 -e "s:-arch\s\w*::g" \
198 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
199 314
200 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
201 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 316 # fix arch handling (automagically duplicates our -arch arg and breaks
202 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 317 # pch). Additionally disable Xarch support.
203 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
322 sed \
323 -e "s:-arch i386::" \
324 -e "s:-arch ppc::" \
325 -e "s:-arch x86_64::" \
326 -e "s:-arch ppc64::" \
327 -e "s:-arch \$i::" \
328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
330 -e "s:-Xarch_x86_64::g" \
331 -e "s:-Xarch_ppc64::g" \
332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
334
335 # On Snow Leopard don't fall back to 10.5 deployment target.
336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
341 fi
342 fi
343
344 # this one is needed for all systems with a separate -liconv, apart from
345 # Darwin, for which the sources already cater for -liconv
346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
348 -i config.tests/unix/iconv/iconv.pro \
349 || die "sed iconv.pro failed"
350 fi
351
352 # we need some patches for Solaris
353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
355 # use GCC over SunStudio
356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
357 # do not flirt with non-Prefix stuff, we're quite possessive
358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
204 360
205 base_src_prepare 361 base_src_prepare
206} 362}
207 363
208# @FUNCTION: qt4-build_src_configure 364# @FUNCTION: qt4-build_src_configure
209# @DESCRIPTION: 365# @DESCRIPTION:
210# Default configure phase 366# Default configure phase
211qt4-build_src_configure() { 367qt4-build_src_configure() {
368 setqtenv
212 369
213 myconf="$(standard_configure_options) ${myconf}"
214
215 echo ./configure ${myconf}
216 ./configure ${myconf} || die "./configure failed"
217}
218
219# @FUNCTION: qt4-build_src_compile
220# @DESCRIPTION: Actual compile phase
221qt4-build_src_compile() {
222 # Be backwards compatible for now
223 if [[ $EAPI != 2 ]]; then
224 qt4-build_src_configure
225 fi
226
227 build_directories "${QT4_TARGET_DIRECTORIES}"
228}
229
230# @FUNCTION: qt4-build_src_install
231# @DESCRIPTION:
232# Perform the actual installation including some library fixes.
233qt4-build_src_install() {
234 install_directories "${QT4_TARGET_DIRECTORIES}"
235 install_qconfigs
236 fix_library_files
237}
238
239# @FUNCTION: standard_configure_options
240# @DESCRIPTION:
241# Sets up some standard configure options, like libdir (if necessary), whether
242# debug info is wanted or not.
243standard_configure_options() {
244 local myconf="" 370 local conf="
245 371 -prefix ${QTPREFIXDIR}
246 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 372 -bindir ${QTBINDIR}
247 373 -libdir ${QTLIBDIR}
248 # Disable visibility explicitly if gcc version isn't 4 374 -docdir ${QTDOCDIR}
249 if [[ "$(gcc-major-version)" -lt "4" ]]; then 375 -headerdir ${QTHEADERDIR}
250 myconf="${myconf} -no-reduce-exports" 376 -plugindir ${QTPLUGINDIR}
251 fi 377 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
252 378 -datadir ${QTDATADIR}
253 # precompiled headers doesn't work on hardened, where the flag is masked. 379 -translationdir ${QTTRANSDIR}
254 if use pch; then 380 -sysconfdir ${QTSYSCONFDIR}
255 myconf="${myconf} -pch" 381 -examplesdir ${QTEXAMPLESDIR}
256 else 382 -demosdir ${QTDEMOSDIR}
257 myconf="${myconf} -no-pch" 383 -opensource -confirm-license
258 fi 384 -shared -fast -largefile -stl -verbose
259 385 -nomake examples -nomake demos"
260 if use debug; then
261 myconf="${myconf} -debug -no-separate-debug-info"
262 else
263 myconf="${myconf} -release -no-separate-debug-info"
264 fi
265 386
266 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 387 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
267 # $(tc-arch). Therefore we convert it to supported values. 388 # $(tc-arch). Therefore we convert it to supported values.
268 case "$(tc-arch)" in 389 case "$(tc-arch)" in
269 amd64) myconf="${myconf} -arch x86_64" ;; 390 amd64|x64-*) conf+=" -arch x86_64" ;;
391 ppc-macos) conf+=" -arch ppc" ;;
270 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 392 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
393 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
394 x86-macos) conf+=" -arch x86" ;;
271 x86|x86-*) myconf="${myconf} -arch i386" ;; 395 x86|x86-*) conf+=" -arch i386" ;;
272 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 396 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
273 hppa|sh) myconf="${myconf} -arch generic" ;; 397 hppa|sh) conf+=" -arch generic" ;;
274 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 398 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
275 esac 399 esac
276 400
277 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath 401 conf+=" -platform $(qt_mkspecs_dir)"
278 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
279 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
280 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
281 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
282 -demosdir ${QTDEMOSDIR} -silent -fast
283 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
284 -reduce-relocations -nomake examples -nomake demos"
285 402
286 # Make eclass 4.5.{1,2} ready 403 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
287 case "${MY_PV}" in
288 4.5.1 | 4.5.2)
289 myconf="${myconf} -opensource"
290 ;;
291 esac
292 404
405 # debug/release
406 if use debug; then
407 conf+=" -debug"
408 else
409 conf+=" -release"
410 fi
411 conf+=" -no-separate-debug-info"
412
413 # exceptions USE flag
414 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
415
416 # disable RPATH on Qt >= 4.8 (bug 380415)
417 version_is_at_least 4.8 && conf+=" -no-rpath"
418
419 # precompiled headers don't work on hardened, where the flag is masked
420 conf+=" $(qt_use pch)"
421
422 # -reduce-relocations
423 # This flag seems to introduce major breakage to applications,
424 # mostly to be seen as a core dump with the message "QPixmap: Must
425 # construct a QApplication before a QPaintDevice" on Solaris.
426 # -- Daniel Vergien
427 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
428
429 # this one is needed for all systems with a separate -liconv, apart from
430 # Darwin, for which the sources already cater for -liconv
431 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
432 conf+=" -liconv"
433 fi
434
435 if use_if_iuse glib; then
436 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
437 # avoid the -pthread argument
438 conf+=" ${glibflags//-pthread}"
439 unset glibflags
440 fi
441
442 if use_if_iuse qpa; then
443 echo
444 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
445 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
446 ewarn "disable it before reporting any bugs related to this useflag."
447 echo
448 conf+=" -qpa"
449 fi
450
451 if use aqua; then
452 # On (snow) leopard use the new (frameworked) cocoa code.
453 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
454 conf+=" -cocoa -framework"
455 # We need the source's headers, not the installed ones.
456 conf+=" -I${S}/include"
457 # Add hint for the framework location.
458 conf+=" -F${QTLIBDIR}"
459
460 # We are crazy and build cocoa + qt3support :-)
461 if use qt3support; then
462 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
463 -i configure || die
464 fi
465 else
466 conf+=" -no-framework"
467 fi
468 else
469 # freetype2 include dir is non-standard, thus pass it to configure
470 conf+=" $(pkg-config --cflags-only-I freetype2)"
471 fi
472
293 echo "${myconf}" 473 conf+=" ${myconf}"
474 myconf=
475
476 echo ./configure ${conf}
477 ./configure ${conf} || die "./configure failed"
478
479 prepare_directories ${QT4_TARGET_DIRECTORIES}
294} 480}
481
482# @FUNCTION: qt4-build_src_compile
483# @DESCRIPTION:
484# Actual compile phase
485qt4-build_src_compile() {
486 setqtenv
487
488 build_directories ${QT4_TARGET_DIRECTORIES}
489}
490
491# @FUNCTION: qt4-build_src_test
492# @DESCRIPTION:
493# Runs tests only in target directories.
494qt4-build_src_test() {
495 # QtMultimedia does not have any test suite (bug #332299)
496 [[ ${PN} == qt-multimedia ]] && return
497
498 for dir in ${QT4_TARGET_DIRECTORIES}; do
499 emake -j1 check -C ${dir}
500 done
501}
502
503# @FUNCTION: fix_includes
504# @DESCRIPTION:
505# For MacOS X we need to add some symlinks when frameworks are
506# being used, to avoid complications with some more or less stupid packages.
507fix_includes() {
508 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
509 local frw dest f h rdir
510 # Some packages tend to include <Qt/...>
511 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
512
513 # Fake normal headers when frameworks are installed... eases life later
514 # on, make sure we use relative links though, as some ebuilds assume
515 # these dirs exist in src_install to add additional files
516 f=${QTHEADERDIR}
517 h=${QTLIBDIR}
518 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
519 f=${f#*/}
520 h=${h#*/}
521 done
522 rdir=${h}
523 f="../"
524 while [[ ${h} == */* ]] ; do
525 f="${f}../"
526 h=${h#*/}
527 done
528 rdir="${f}${rdir}"
529
530 for frw in "${D}${QTLIBDIR}"/*.framework; do
531 [[ -e "${frw}"/Headers ]] || continue
532 f=$(basename ${frw})
533 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
534 dosym "${rdir}"/${f}/Headers "${dest}"
535
536 # Link normal headers as well.
537 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
538 h=$(basename ${hdr})
539 dosym "../${rdir}"/${f}/Headers/${h} \
540 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
541 done
542 done
543 fi
544}
545
546# @FUNCTION: qt4-build_src_install
547# @DESCRIPTION:
548# Perform the actual installation including some library fixes.
549qt4-build_src_install() {
550 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
551 setqtenv
552
553 install_directories ${QT4_TARGET_DIRECTORIES}
554 install_qconfigs
555 fix_library_files
556 fix_includes
557
558 # remove .la files since we are building only shared Qt libraries
559 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
560}
561
562# @FUNCTION: setqtenv
563# @INTERNAL
564setqtenv() {
565 # Set up installation directories
566 QTPREFIXDIR=${EPREFIX}/usr
567 QTBINDIR=${EPREFIX}/usr/bin
568 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
569 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
570 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
571 QTHEADERDIR=${EPREFIX}/usr/include/qt4
572 QTPLUGINDIR=${QTLIBDIR}/plugins
573 QTIMPORTDIR=${QTLIBDIR}/imports
574 QTDATADIR=${EPREFIX}/usr/share/qt4
575 QTTRANSDIR=${QTDATADIR}/translations
576 QTSYSCONFDIR=${EPREFIX}/etc/qt4
577 QTEXAMPLESDIR=${QTDATADIR}/examples
578 QTDEMOSDIR=${QTDATADIR}/demos
579 QMAKE_LIBDIR_QT=${QTLIBDIR}
580 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
581
582 PLATFORM=$(qt_mkspecs_dir)
583 unset QMAKESPEC
584
585 export XDG_CONFIG_HOME="${T}"
586}
587
588# @FUNCTION: prepare_directories
589# @USAGE: < directories >
590# @INTERNAL
591# @DESCRIPTION:
592# Generates Makefiles for the given list of directories.
593prepare_directories() {
594 for x in "$@"; do
595 pushd "${S}"/${x} >/dev/null || die
596 einfo "Running qmake in: ${x}"
597 # avoid running over the maximum argument number, bug #299810
598 {
599 echo "${S}"/mkspecs/common/*.conf
600 find "${S}" -name '*.pr[io]'
601 } | xargs sed -i \
602 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
603 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
604 || die
605 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
606 popd >/dev/null || die
607 done
608}
609
295 610
296# @FUNCTION: build_directories 611# @FUNCTION: build_directories
297# @USAGE: < directories > 612# @USAGE: < directories >
613# @INTERNAL
298# @DESCRIPTION: 614# @DESCRIPTION:
299# Compiles the code in $QT4_TARGET_DIRECTORIES 615# Compiles the code in the given list of directories.
300build_directories() { 616build_directories() {
301 local dirs="$@"
302 for x in ${dirs}; do 617 for x in "$@"; do
303 cd "${S}"/${x} 618 pushd "${S}"/${x} >/dev/null || die
304 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 619 emake CC="$(tc-getCC)" \
305 emake || die "emake failed" 620 CXX="$(tc-getCXX)" \
621 LINK="$(tc-getCXX)" || die "emake failed"
622 popd >/dev/null || die
306 done 623 done
307} 624}
308 625
309# @FUNCTION: install_directories 626# @FUNCTION: install_directories
310# @USAGE: < directories > 627# @USAGE: < directories >
628# @INTERNAL
311# @DESCRIPTION: 629# @DESCRIPTION:
312# run emake install in the given directories, which are separated by spaces 630# Runs emake install in the given directories, which are separated by spaces.
313install_directories() { 631install_directories() {
314 local dirs="$@"
315 for x in ${dirs}; do 632 for x in "$@"; do
316 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 633 pushd "${S}"/${x} >/dev/null || die
317 emake INSTALL_ROOT="${D}" install || die "emake install failed" 634 emake INSTALL_ROOT="${D}" install || die "emake install failed"
318 popd >/dev/null || die "Can't popd from ${S}/${x}" 635 popd >/dev/null || die
319 done 636 done
320} 637}
321 638
322# @ECLASS-VARIABLE: QCONFIG_ADD 639# @ECLASS-VARIABLE: QCONFIG_ADD
323# @DESCRIPTION: 640# @DESCRIPTION:
324# List options that need to be added to QT_CONFIG in qconfig.pri 641# List options that need to be added to QT_CONFIG in qconfig.pri
325QCONFIG_ADD="${QCONFIG_ADD:-}" 642: ${QCONFIG_ADD:=}
326 643
327# @ECLASS-VARIABLE: QCONFIG_REMOVE 644# @ECLASS-VARIABLE: QCONFIG_REMOVE
328# @DESCRIPTION: 645# @DESCRIPTION:
329# List options that need to be removed from QT_CONFIG in qconfig.pri 646# List options that need to be removed from QT_CONFIG in qconfig.pri
330QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 647: ${QCONFIG_REMOVE:=}
331 648
332# @ECLASS-VARIABLE: QCONFIG_DEFINE 649# @ECLASS-VARIABLE: QCONFIG_DEFINE
333# @DESCRIPTION: 650# @DESCRIPTION:
334# List variables that should be defined at the top of QtCore/qconfig.h 651# List variables that should be defined at the top of QtCore/qconfig.h
335QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 652: ${QCONFIG_DEFINE:=}
336 653
337# @FUNCTION: install_qconfigs 654# @FUNCTION: install_qconfigs
655# @INTERNAL
656# @DESCRIPTION:
338# @DESCRIPTION: Install gentoo-specific mkspecs configurations 657# Install gentoo-specific mkspecs configurations.
339install_qconfigs() { 658install_qconfigs() {
340 local x 659 local x
341 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 660 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
342 for x in QCONFIG_ADD QCONFIG_REMOVE; do 661 for x in QCONFIG_ADD QCONFIG_REMOVE; do
343 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 662 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
344 done 663 done
345 insinto ${QTDATADIR}/mkspecs/gentoo 664 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
346 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 665 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
347 fi 666 fi
348 667
349 if [[ -n ${QCONFIG_DEFINE} ]]; then 668 if [[ -n ${QCONFIG_DEFINE} ]]; then
350 for x in ${QCONFIG_DEFINE}; do 669 for x in ${QCONFIG_DEFINE}; do
351 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 670 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
352 done 671 done
353 insinto ${QTHEADERDIR}/Gentoo 672 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
354 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 673 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
355 fi 674 fi
356} 675}
357 676
358# @FUNCTION: generate_qconfigs 677# @FUNCTION: generate_qconfigs
359# @DESCRIPTION: Generates gentoo-specific configurations 678# @INTERNAL
679# @DESCRIPTION:
680# Generates gentoo-specific qconfig.{h,pri}.
360generate_qconfigs() { 681generate_qconfigs() {
361 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 682 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
362 local x qconfig_add qconfig_remove qconfig_new 683 local x qconfig_add qconfig_remove qconfig_new
363 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 684 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
364 [[ -f ${x} ]] || continue 685 [[ -f ${x} ]] || continue
365 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 686 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
366 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 687 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
367 done 688 done
368 689
369 # these error checks do not use die because dying in pkg_post{inst,rm} 690 # these error checks do not use die because dying in pkg_post{inst,rm}
370 # just makes things worse. 691 # just makes things worse.
371 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 692 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
378 699
379 # generate list of QT_CONFIG entries from the existing list 700 # generate list of QT_CONFIG entries from the existing list
380 # including qconfig_add and excluding qconfig_remove 701 # including qconfig_add and excluding qconfig_remove
381 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 702 for x in $(sed -n 's/^QT_CONFIG +=//p' \
382 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 703 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
383 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 704 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
384 done 705 done
385 706
386 # replace the existing QT_CONFIG list with qconfig_new 707 # replace the existing QT_CONFIG list with qconfig_new
387 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 708 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
388 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 709 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
412 fi 733 fi
413 fi 734 fi
414} 735}
415 736
416# @FUNCTION: qt4-build_pkg_postrm 737# @FUNCTION: qt4-build_pkg_postrm
738# @DESCRIPTION:
417# @DESCRIPTION: Generate configurations when the package is completely removed 739# Regenerate configuration when the package is completely removed.
418qt4-build_pkg_postrm() { 740qt4-build_pkg_postrm() {
419 generate_qconfigs 741 generate_qconfigs
420} 742}
421 743
422# @FUNCTION: qt4-build_pkg_postinst 744# @FUNCTION: qt4-build_pkg_postinst
745# @DESCRIPTION:
423# @DESCRIPTION: Generate configuration, plus throws a message about possible 746# Regenerate configuration, plus throw a message about possible
424# breakages and proposed solutions. 747# breakages and proposed solutions.
425qt4-build_pkg_postinst() { 748qt4-build_pkg_postinst() {
426 generate_qconfigs 749 generate_qconfigs
427 echo
428 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
429 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
430 ewarn "should recompile the packages providing these plugins. Also, make sure you"
431 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
432 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
433 ewarn
434 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
435 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
436 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
437 ewarn "configuration."
438 ewarn
439 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
440 echo
441} 750}
442 751
443# @FUNCTION: skip_qmake_build_patch 752# @FUNCTION: skip_qmake_build
753# @INTERNAL
444# @DESCRIPTION: 754# @DESCRIPTION:
445# Don't need to build qmake, as it's already installed from qt-core 755# Patches configure to skip qmake compilation, as it's already installed by qt-core.
446skip_qmake_build_patch() { 756skip_qmake_build() {
447 # Don't need to build qmake, as it's already installed from qt-core
448 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 757 sed -i -e "s:if true:if false:g" "${S}"/configure || die
449} 758}
450 759
451# @FUNCTION: skip_project_generation_patch 760# @FUNCTION: skip_project_generation
761# @INTERNAL
452# @DESCRIPTION: 762# @DESCRIPTION:
453# Exit the script early by throwing in an exit before all of the .pro files are scanned 763# Exit the script early by throwing in an exit before all of the .pro files are scanned.
454skip_project_generation_patch() { 764skip_project_generation() {
455 # Exit the script early by throwing in an exit before all of the .pro files are scanned
456 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 765 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
457 -i "${S}"/configure || die "Sed failed"
458} 766}
459 767
460# @FUNCTION: symlink_binaries_to_buildtree 768# @FUNCTION: symlink_binaries_to_buildtree
769# @INTERNAL
461# @DESCRIPTION: 770# @DESCRIPTION:
462# Symlink generated binaries to buildtree so they can be used during compilation 771# Symlinks generated binaries to buildtree, so they can be used during compilation time.
463# time
464symlink_binaries_to_buildtree() { 772symlink_binaries_to_buildtree() {
465 for bin in qmake moc uic rcc; do 773 for bin in qmake moc uic rcc; do
466 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 774 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
467 done 775 done
468} 776}
469 777
470# @FUNCTION: fix_library_files 778# @FUNCTION: fix_library_files
779# @INTERNAL
471# @DESCRIPTION: 780# @DESCRIPTION:
472# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 781# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
473# moves the *.pc-files into the pkgconfig directory 782# moves the *.pc files into the pkgconfig directory.
474fix_library_files() { 783fix_library_files() {
784 local libfile
475 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 785 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
476 if [[ -e ${libfile} ]]; then 786 if [[ -e ${libfile} ]]; then
477 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 787 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
478 fi 788 fi
479 done 789 done
480 790
481 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 791 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
482 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 792 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
483 if [[ -e ${libfile} ]]; then 793 if [[ -e ${libfile} ]]; then
484 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 794 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
485 795
486 # Move .pc files into the pkgconfig directory 796 # Move .pc files into the pkgconfig directory
487 dodir ${QTPCDIR} 797 dodir ${QTPCDIR#${EPREFIX}}
488 mv ${libfile} "${D}"/${QTPCDIR}/ \ 798 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
489 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
490 fi 799 fi
491 done 800 done
492 801
493 # Don't install an empty directory 802 # Don't install an empty directory
494 rmdir "${D}"/${QTLIBDIR}/pkgconfig 803 rmdir "${D}"/${QTLIBDIR}/pkgconfig
495} 804}
496 805
497# @FUNCTION: qt_use 806# @FUNCTION: qt_use
498# @USAGE: < flag > [ feature ] [ enableval ] 807# @USAGE: < flag > [ feature ] [ enableval ]
499# @DESCRIPTION: 808# @DESCRIPTION:
500# This will echo "${enableval}-${feature}" if <flag> is enabled, or 809# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
501# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 810# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
502# will be used for that. If [enableval] is not specified, it omits the 811# will be used for that. If [enableval] is not specified, it omits the
503# assignment-part 812# "-${enableval}" part.
504qt_use() { 813qt_use() {
505 local flag="${1}" 814 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
506 local feature="${1}"
507 local enableval=
508
509 [[ -n ${2} ]] && feature=${2}
510 [[ -n ${3} ]] && enableval="-${3}"
511
512 if use ${flag}; then
513 echo "${enableval}-${feature}"
514 else
515 echo "-no-${feature}"
516 fi
517}
518
519# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
520# @DESCRIPTION:
521# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
522# (eutils.eclass), line per line.
523#
524# Example:
525# @CODE
526# pkg_setup() {
527# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
528# ~x11-libs/qt-gui-${PV} qt3support"
529# qt4-build_check_use
530# }
531# @CODE
532
533# Run built_with_use on each flag and print appropriate error messages if any
534# flags are missing
535
536_qt_built_with_use() {
537 local missing opt pkg flag flags
538
539 if [[ ${1} = "--missing" ]]; then
540 missing="${1} ${2}" && shift 2
541 fi
542 if [[ ${1:0:1} = "-" ]]; then
543 opt=${1} && shift
544 fi
545
546 pkg=${1} && shift
547
548 for flag in "${@}"; do
549 flags="${flags} ${flag}"
550 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
551 flags="${flags}*"
552 else
553 [[ ${opt} = "-o" ]] && return 0
554 fi
555 done
556 if [[ "${flags# }" = "${@}" ]]; then
557 return 0
558 fi
559 if [[ ${opt} = "-o" ]]; then
560 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
561 else
562 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
563 fi
564 return 1
565}
566
567# @FUNCTION: qt4-build_check_use
568# @DESCRIPTION:
569# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
570# USE flags listed.
571#
572# If any of the required USE flags are missing, an eerror will be printed for
573# each package with missing USE flags.
574qt4-build_check_use() {
575 local line missing
576 while read line; do
577 [[ -z ${line} ]] && continue
578 if ! _qt_built_with_use ${line}; then
579 missing=true
580 fi
581 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
582 if [[ -n ${missing} ]]; then
583 echo
584 eerror "Flags marked with an * are missing."
585 die "Missing USE flags found"
586 fi
587} 815}
588 816
589# @FUNCTION: qt_mkspecs_dir 817# @FUNCTION: qt_mkspecs_dir
590# @RETURN: the specs-directory w/o path 818# @RETURN: the specs-directory w/o path
591# @DESCRIPTION: 819# @DESCRIPTION:
592# Allows us to define which mkspecs dir we want to use. 820# Allows us to define which mkspecs dir we want to use.
593qt_mkspecs_dir() { 821qt_mkspecs_dir() {
594 # Allows us to define which mkspecs dir we want to use.
595 local spec 822 local spec=
596 823
597 case ${CHOST} in 824 case "${CHOST}" in
598 *-freebsd*|*-dragonfly*) 825 *-freebsd*|*-dragonfly*)
599 spec="freebsd" ;; 826 spec=freebsd ;;
600 *-openbsd*) 827 *-openbsd*)
601 spec="openbsd" ;; 828 spec=openbsd ;;
602 *-netbsd*) 829 *-netbsd*)
603 spec="netbsd" ;; 830 spec=netbsd ;;
604 *-darwin*) 831 *-darwin*)
832 if use aqua; then
833 # mac with carbon/cocoa
834 spec=macx
835 else
836 # darwin/mac with x11
605 spec="darwin" ;; 837 spec=darwin
838 fi
839 ;;
840 *-solaris*)
841 spec=solaris ;;
606 *-linux-*|*-linux) 842 *-linux-*|*-linux)
607 spec="linux" ;; 843 spec=linux ;;
608 *) 844 *)
609 die "Unknown CHOST, no platform choosen." 845 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
610 esac 846 esac
611 847
612 CXX=$(tc-getCXX) 848 case "$(tc-getCXX)" in
613 if [[ ${CXX/g++/} != ${CXX} ]]; then 849 *g++*)
614 spec="${spec}-g++" 850 spec+=-g++ ;;
615 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 851 *icpc*)
616 spec="${spec}-icc" 852 spec+=-icc ;;
617 else 853 *)
618 die "Unknown compiler ${CXX}." 854 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
855 esac
856
857 # Add -64 for 64bit profiles
858 if use x64-freebsd ||
859 use amd64-linux ||
860 use x64-macos ||
861 use x64-solaris ||
862 use sparc64-solaris
863 then
864 spec+=-64
619 fi 865 fi
620 866
621 echo "${spec}" 867 echo "${spec}"
622} 868}
623 869
624case ${EAPI:-0} in 870# @FUNCTION: qt_assistant_cleanup
625 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 871# @INTERNAL
872# @DESCRIPTION:
873# Tries to clean up tools.pro for qt-assistant ebuilds.
874# Meant to be called in src_prepare().
875# Since Qt 4.7.4 this function is a no-op.
876qt_assistant_cleanup() {
877 # apply patching to qt-assistant ebuilds only
878 [[ ${PN} != qt-assistant ]] && return
879
880 # no longer needed for 4.7.4 and later
881 version_is_at_least 4.7.4 && return
882
883 # different versions (and branches...) may need different handling,
884 # add a case if you need special handling
885 case "${MY_PV_EXTRA}" in
886 *kde-qt*)
887 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
888 -e "/mac/,/^embedded.*makeqpf$/d" \
889 -i tools/tools.pro || die "patching tools.pro failed"
890 ;;
891 *)
892 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
893 -e "/mac/,/^embedded.*makeqpf$/d" \
894 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
895 -i tools/tools.pro || die "patching tools.pro failed"
896 ;;
897 esac
898}
899
900# @FUNCTION: qt_nolibx11
901# @INTERNAL
902# @DESCRIPTION:
903# Ignore X11 tests for packages that don't need X libraries installed.
904qt_nolibx11() {
905 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
906 die "x11 check sed failed"
907}
908
626 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 909EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
627esac

Legend:
Removed from v.1.40  
changed lines
  Added in v.1.129

  ViewVC Help
Powered by ViewVC 1.1.20